ks 1 xs _ = xs -- The (10^5)th 47-smooth number: 9,854,432  time:36min
ks n xs zs@[q2,q3,q5,q7,q11,q13,q17,q19,q23,q29,q31,q37,q41,q43,q47] = ks (n-1) (xs++[x]) update where
  x = minimum $ map head zs
  update
    | x == head q2  = [(tail q2)++[x*2],q3++[x*3],q5++[x*5],q7++[x*7],q11++[x*11],q13++[x*13],q17++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q3  = [q2,(tail q3)++[x*3],q5++[x*5],q7++[x*7],q11++[x*11],q13++[x*13],q17++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q5  = [q2,q3,(tail q5)++[x*5],q7++[x*7],q11++[x*11],q13++[x*13],q17++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q7  = [q2,q3,q5,(tail q7)++[x*7],q11++[x*11],q13++[x*13],q17++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q11 = [q2,q3,q5,q7,(tail q11)++[x*11],q13++[x*13],q17++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q13 = [q2,q3,q5,q7,q11,(tail q13)++[x*13],q17++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q17 = [q2,q3,q5,q7,q11,q13,(tail q17)++[x*17],q19++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q19 = [q2,q3,q5,q7,q11,q13,q17,(tail q19)++[x*19],q23++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q23 = [q2,q3,q5,q7,q11,q13,q17,q19,(tail q23)++[x*23],q29++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q29 = [q2,q3,q5,q7,q11,q13,q17,q19,q23,(tail q29)++[x*29],q31++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q31 = [q2,q3,q5,q7,q11,q13,q17,q19,q23,q29,(tail q31)++[x*31],q37++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q37 = [q2,q3,q5,q7,q11,q13,q17,q19,q23,q29,q31,(tail q37)++[x*37],q41++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q41 = [q2,q3,q5,q7,q11,q13,q17,q19,q23,q29,q31,q37,(tail q41)++[x*41],q43++[x*43],q47++[x*47]]
    | x == head q43 = [q2,q3,q5,q7,q11,q13,q17,q19,q23,q29,q31,q37,q41,(tail q43)++[x*43],q47++[x*47]]
    | True          = [q2,q3,q5,q7,q11,q13,q17,q19,q23,q29,q31,q37,q41,q43,(tail q47)++[x*47]]
s47 n = ks n [1] [[2],[3],[5],[7],[11],[13],[17],[19],[23],[29],[31],[37],[41],[43],[47]]
f zs _ [] = zs
f zs (x:xs) (y:ys)
  | z < y = f zs xs (y:ys)
  | z > y = f zs (x:xs) ys
  | True  = f (x:zs) xs ys
  where z = div (x*x+x) 2
main = let n = 10^4 in print $ sum $ f [] [1..] $ s47 n

